import { Opaque } from '@glimmer/util';
import { RootReference as IRootReference } from '../types';
import { PathReference as IPathReference, Tag } from '@glimmer/reference';
import { Option } from "@glimmer/interfaces";
export default class RootReference<T> implements IRootReference<T>, IPathReference<T> {
    private object;
    private chains;
    tag: Tag;
    constructor(object: T);
    value(): T;
    update(object: T): void;
    get<U>(prop: string): IPathReference<U>;
    chainFor<U>(prop: string): Option<IPathReference<U>>;
    path(string: string): IPathReference<Opaque>;
    referenceFromParts(parts: string[]): IPathReference<Opaque>;
    label(): string;
}
