import './lib/bootstrap';
export { default as templateFactory } from './lib/template';
export { NULL_REFERENCE, UNDEFINED_REFERENCE, PrimitiveReference, ConditionalReference } from './lib/references';
export { default as OpcodeBuilderDSL } from './lib/compiled/opcodes/builder';
export { compileLayout } from './lib/compiler';
export { CompiledStaticTemplate, CompiledDynamicTemplate } from './lib/compiled/blocks';
export { AttributeManager as IAttributeManager, AttributeManager, PropertyManager, INPUT_VALUE_PROPERTY_MANAGER, defaultManagers, defaultAttributeManagers, defaultPropertyManagers, readDOMAttr } from './lib/dom/attribute-managers';
export { Register, debugSlice } from './lib/opcodes';
export { normalizeTextValue } from './lib/compiled/opcodes/content';
export { setDebuggerCallback, resetDebuggerCallback } from './lib/compiled/opcodes/debugger';
export { default as getDynamicVar } from './lib/helpers/get-dynamic-var';
export { Blocks as BlockMacros, Inlines as InlineMacros, compileList, expr as compileExpression } from './lib/syntax/functions';
export { UpdatingVM, RenderResult } from './lib/vm';
export { isSafeString } from './lib/upsert';
export { Scope, default as Environment } from './lib/environment';
export { PartialDefinition } from './lib/partial';
export { ComponentDefinition, isComponentDefinition } from './lib/component/interfaces';
export { default as DOMChanges, DOMChanges as IDOMChanges, DOMTreeConstruction, isWhitespace, insertHTMLBefore } from './lib/dom/helper';
import * as Simple from './lib/dom/interfaces';
export { Simple };
export { ElementStack } from './lib/builder';
export { ConcreteBounds } from './lib/bounds';